# balle_verticale.pyde - extension ajoutée par Processing

# La fonction setup met en place la taille de la fenêtre,
# la vitesse d'horloge, les éléments fixes de l'animation
# et les variables globales.

def setup() :
    size(80,400)                        # width=80, height=400
    frameRate(40)                       # 60 img/sec (le défaut)
    global x, y, dy, rayon, diametre, frot, grav    # variables globales
    (x, y, dy) = (width/2, 100, 0)      # pos. et vitesse initiales
    # les constantes physiques
    rayon = 20                          # rayon de la balle
    diametre = 2 * rayon
    fill(50,150,100)                    # couleur de remplissage
    frot = 0.92                         # coefficient multiplicatif de frottement au sol
    grav = 0.7                          # gravitation additive à la vitesse
    print('Lancement...')

# La fonction draw est automatiquement déclenchée tous les 60ème de seconde 
# (réglable avec {\tt frameRate}). On la stoppe avec l'instruction noLoop().

def draw() :
    background(255,255,0)               # effacement par un fond jaune
    global y, dy
    ellipse(x,y,diametre,diametre)      # affichage de la balle
    ys = y + dy                         # position suivante ?
    if ys <= height - rayon :           # elle est dans le canevas
        y = ys
        dy = dy + grav
    else :
        y = height - rayon              # non : on la pose au sol
        dy = dy - grav
        dy = - dy * frot                # inversion + frottement
    if (abs(y+rayon-height) < 1) and (abs(dy) < 1) :       # quasi fini ?
        noLoop()                        # on coupe l'horloge !
        print('Fini !')
